Subject: Do I need to skb_put() Ethernet frames to a minimum of 60 bytes?

From: Arvid Brodin <[email-masked]>
Date: Tue, 14 Aug 2012 18:53:57 +0000

Hi,

If I create an sk_buff with a payload of less than 28 bytes (ethheader + data),
and send it using the cadence/macb (Ethernet) driver, I get

eth0: TX underrun, resetting buffers

Now I know the minimum Ethernet frame size is 64 bytes (including the 4-byte
FCS), but whose responsibility is it to pad the frame to this size if necessary?
Mine or the driver's - i.e. should I just skb_put() to the minimum size or
should I report the underrun as a driver bug?

-- 
Arvid Brodin | Consultant (Linux)
XDIN AB | Jan Stenbecks Torg 17 | SE-164 40 Kista | Sweden | xdin.com